#ifndef _WIN32_IE
#define _WIN32_IE 0x0400    //for commctrl, datetime
#endif
#include <windows.h>
#include <Powrprof.h>
#include <commctrl.h>
#include <string.h>
#include "main.h"
#include "shutdown.h"
#include "resource.h"

MSG_CALLBACK mcb;
HANDLE Thread;
HANDLE SessionMutex;

HWND hwndDP = NULL;
SYSTEMTIME stShutdown;      ///< requested time of shutdown
bool bDeployed = false;     ///< are you ready to shutdown?
bool bVisible = false;
HANDLE hwndGlobalDialog = NULL;
const char *myname = "System Shutdown";
char *inifile = NULL;

HINSTANCE hInst;

SYSTEM_POWER_CAPABILITIES powerCapabilities;

enum ACTION
{
    ACTION_NONE = 0,
    ACTION_S3,
    ACTION_S4,
    ACTION_SHUTDOWN
} action;

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    INITCOMMONCONTROLSEX icex;
    HWND hCtl;
    LRESULT lResult;
    //char lpDateTime[64];
    char tmpbuf[10];
    hwndGlobalDialog = hwndDlg;
    switch (uMsg)
    {
    case WM_INITDIALOG:
        /*
         * TODO: Add code to initialize the dialog.
         */
        icex.dwSize = sizeof(icex);
        icex.dwICC = ICC_DATE_CLASSES;

        InitCommonControlsEx(&icex);
        if (hwndDlg)
            hwndDP = CreateWindowEx(0,
                                    DATETIMEPICK_CLASS,
                                    TEXT("DateTime"),
                                    WS_BORDER|WS_CHILD|WS_VISIBLE|DTS_UPDOWN|DTS_TIMEFORMAT,
                                    140,5,80,25,
                                    hwndDlg,
                                    NULL,
                                    NULL,
                                    NULL);
        if (bDeployed)
        {
            ::SendMessage(hwndDP, DTM_SETSYSTEMTIME, 0, (LPARAM)&stShutdown);
        }

        // disable S3, S4 options
        hCtl = GetDlgItem(hwndDlg, IDC_S3);
        EnableWindow(hCtl, FALSE);
        hCtl = GetDlgItem(hwndDlg, IDC_S4);
        EnableWindow(hCtl, FALSE);
        hCtl = GetDlgItem(hwndDlg, IDC_SHUTDOWN);
        EnableWindow(hCtl, FALSE);
        if (GetPwrCapabilities(&powerCapabilities))
        {
            if (powerCapabilities.SystemS3)
            {
                hCtl = GetDlgItem(hwndDlg, IDC_S3);
                EnableWindow(hCtl, TRUE);
            }
            if (powerCapabilities.SystemS4 && powerCapabilities.HiberFilePresent)
            {
                hCtl = GetDlgItem(hwndDlg, IDC_S4);
                EnableWindow(hCtl, TRUE);
            }
            if (powerCapabilities.SystemS5)
            {
                hCtl = GetDlgItem(hwndDlg, IDC_SHUTDOWN);
                EnableWindow(hCtl, TRUE);
            }
        }
        else
            DisplayError( GetLastError(), "FreeGG plugin", "Bd przy pobieraniu informacji o dostpnych stanach upienia systemu.\n");

        if (action == ACTION_S3)
            SendMessage(GetDlgItem(hwndDlg, IDC_S3), BM_SETCHECK, 1, 0);
        else if (action == ACTION_S4)
            SendMessage(GetDlgItem(hwndDlg, IDC_S3), BM_SETCHECK, 1, 0);
        else
            SendMessage(GetDlgItem(hwndDlg, IDC_SHUTDOWN), BM_SETCHECK, 1, 0);

        return TRUE;

    case WM_CLOSE:
        bVisible = false;
        hwndGlobalDialog = NULL;
        EndDialog(hwndDlg, 0);
        return TRUE;

    case WM_COMMAND:
        switch (LOWORD(wParam))
        {
            /*
             * TODO: Add more control ID's, when needed.
             */
        case IDC_BTN_ABORT:
            bDeployed = false;
            AbortSystemShutdown(NULL);
            bVisible = false;
            hwndGlobalDialog = NULL;
            EndDialog(hwndDlg, 0);
            return TRUE;

        case IDC_BTN_OK:
            // which radio button is checked?
            lResult = SendMessage(GetDlgItem(hwndDlg, IDC_S3), BM_GETCHECK, 0, 0);
            if (lResult == BST_CHECKED)
            {
                ::SendMessage(hwndDP, DTM_GETSYSTEMTIME, 0, (LPARAM)&stShutdown);
                bDeployed = true;
                action = ACTION_S3;
                if (inifile)
                {
                    itoa(action, tmpbuf, 10);
                    WritePrivateProfileString("Action", "Type", tmpbuf, inifile);
                }
                bVisible = false;
                hwndGlobalDialog = NULL;
                EndDialog(hwndDlg, 0);
                return TRUE;
            }
            lResult = SendMessage(GetDlgItem(hwndDlg, IDC_S4), BM_GETCHECK, 0, 0);
            if (lResult == BST_CHECKED)
            {
                ::SendMessage(hwndDP, DTM_GETSYSTEMTIME, 0, (LPARAM)&stShutdown);
                bDeployed = true;
                action = ACTION_S4;
                if (inifile)
                {
                    itoa(action, tmpbuf, 10);
                    WritePrivateProfileString("Action", "Type", tmpbuf, inifile);
                }
                bVisible = false;
                hwndGlobalDialog = NULL;
                EndDialog(hwndDlg, 0);
                return TRUE;
            }
            lResult = SendMessage(GetDlgItem(hwndDlg, IDC_SHUTDOWN), BM_GETCHECK, 0, 0);
            if (lResult == BST_CHECKED)
            {
                if ( ! SetCurrentPrivilege( SE_SHUTDOWN_NAME, TRUE ) )
                    DisplayError( GetLastError(), "FreeGG plugin", "Brak uprawnie do operacji zamknicia systemu.\n");
                else
                {
                    ::SendMessage(hwndDP, DTM_GETSYSTEMTIME, 0, (LPARAM)&stShutdown);
                    bDeployed = true;
                    action = ACTION_SHUTDOWN;
                    if (inifile)
                    {
                        itoa(action, tmpbuf, 10);
                        WritePrivateProfileString("Action", "Type", tmpbuf, inifile);
                    }
                    bVisible = false;
                    hwndGlobalDialog = NULL;
                    EndDialog(hwndDlg, 0);
                }
                return TRUE;
            }

            MessageBox(NULL, "adna opcja dziaania nie zostaa wybrana", myname, MB_OK);
            return TRUE;
        }
    }

    return FALSE;
}


const __int64 nano100SecInSec=(__int64)10000000;
/*1. Diffence BETWEEN two datetime
////////////
//equivalent of DATEDIFF function from SQLServer
//Returns the number of date and time boundaries crossed
//between two specified dates.
////////////*/
double     /* return count of period between pst1 and pst2*/
DT_PeriodsBetween
(
    const __int64 datepart, /*datepart that we want to count, {nano100SecInDay ...}*/
    const SYSTEMTIME* pst1, /*valid datetime*/
    const SYSTEMTIME* pst2  /*valid datetime*/
)
{
    FILETIME ft1,ft2;
    __int64 *pi1,*pi2;

    /*convert SYSTEMTIME to FILETIME
    //SYSTEMTIME is only representation, so need convert to
    //FILETIME for make some calculation*/
    SystemTimeToFileTime (pst1,&ft1);
    SystemTimeToFileTime (pst2,&ft2);
    /*convert FILETIME to __int64
    //FILETIME is struct with two DWORD, for receive
    //ability calculation we must reference to FILETIME as to int*/
    pi1 = (__int64*)&ft1;
    pi2 = (__int64*)&ft2;
    /*compare two datetimes and (bigger date - smaller date)/period*/
    return (CompareFileTime(&ft1,&ft2)==1) ?
           (((*pi1)-(*pi2))/(double)datepart) : (((*pi2)-(*pi1))/(double)datepart);
}

DWORD WINAPI ThreadProc(LPVOID data)
{
    SYSTEMTIME st;
    DWORD rc;

    const int period = 3;
    while (1)
    {
        //OutputDebugStr("plugin System Shutdown is running");
        if (bDeployed)
        {
            GetLocalTime(&st);
            if (DT_PeriodsBetween(nano100SecInSec,&st,&stShutdown)<=period)
            {
                bDeployed = false;
                if (action == ACTION_S3)
                {
                    if (!SetSuspendState(FALSE, TRUE, FALSE))
                        DisplayError( GetLastError(), "FreeGG plugin", "Przejcie do stanu STANDBY (S3) nie powiodo si.\n" );
                }
                else if (action == ACTION_S4)
                {
                    if (!SetSuspendState(TRUE, TRUE, FALSE))
                        DisplayError( GetLastError(), "FreeGG plugin", "Przejcie do stanu HIBERNATE (S4) nie powiodo si.\n" );
                }
                else if (action == ACTION_SHUTDOWN)
                {
                    //ShellExecute(0, "open", "shutdown", "-s -t 30", NULL, 0);
                    rc = InitiateSystemShutdown( NULL,
                                                 "Zamykanie systemu zainicjowane przez plugin FreeGG... "
                                                 "Wywoaj plugin i wcinij 'Rozbrj' aby przerwa proces. "
                                                 "Uwaga: okno pluginu moe pokaza si pod tym oknem.", (DWORD) 60, true, false );
                    if ( ! rc )
                        DisplayError( GetLastError(), "FreeGG plugin", "Zamykanie systemu nie powiodo si.\n" );
                }
                else
                    DisplayError( 0, "FreeGG plugin", "Nieznany/niezaimplementowany typ dziaania.\n" );
            }
        }
        Sleep(period*1000);
    }
    return 0;
}

/** get handle to dll without knowing its name
*/
HMODULE GetCurrentModule()
{
    MEMORY_BASIC_INFORMATION mbi;
    static int dummy;
    VirtualQuery( &dummy, &mbi, sizeof(mbi) );
    return reinterpret_cast<HMODULE>(mbi.AllocationBase);
}

DWORD WINAPI ThreadDialog(LPVOID data)
{
    int ret = DialogBox(GetCurrentModule(),
                        MAKEINTRESOURCE(DLG_MAIN), NULL, DialogProc);
    if (ret </*=*/ 0)   ///< \todo poprawne wywolanie daje 0?
    {
        LPVOID lpMsgBuf;
        DWORD dw = GetLastError();

        FormatMessage(
            FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM |
            FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL,
            dw,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (LPTSTR) &lpMsgBuf,
            0, NULL );
        MessageBox(NULL, (LPCTSTR)lpMsgBuf, TEXT("Error"), MB_OK);
        LocalFree(lpMsgBuf);
        bVisible = false;
    }
    return 0;
}

char* Name()
{
    return (char*)myname;
}

int Load(MSG_CALLBACK callback)
{
    DWORD dwtid;
    mcb = callback;
    Thread = CreateThread(NULL,0,ThreadProc,0,0,&dwtid);
    return 0;
}

int Unload()
{
    TerminateThread(Thread,0);
    return 0;
}


inline bool StartsWith(char* &a, char *b)
{
    if (strlen(a) < strlen(b))
    {
        return false;
    }
    else
    {
        bool result = !strnicmp(a,b,strlen(b));
        if (result)
            a += strlen(b);
        return result;
    }
}


int HandleMessage(char* message)
{
    if (StartsWith(message,"show main"))
    {
        if (!bVisible)
        {
            DWORD dwtid;
            bVisible = true;
            CreateThread(NULL,0,ThreadDialog,0,0,&dwtid);
        }
        else
        {
            if (hwndGlobalDialog)
                SetWindowPos( (HWND__*)hwndGlobalDialog, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE );
        }
    }
    else if (StartsWith(message,"config inipath "))
    {
        if (inifile)
            delete [] inifile;
        char    buf[MAX_PATH];
        if (!GetModuleFileName(GetCurrentModule(), buf, MAX_PATH))
            return 1;
        char *dot = strrchr(buf, '.');
        if(!dot)
            return 2;
        dot++;
        if(strlen(dot) < 3) //"dll" expected
            return 3;
        strcpy(dot, "ini");
        char *bs = strrchr(buf, '\\');
        if(!bs)
            bs = buf;
        else
            bs++;

        char *bscut = strrchr (message, '\\');
        if(!bscut)
            return 4;
        *(bscut+1) = '\0';

        // make full ini file name
        inifile = new char[strlen(message) + strlen(bs) + 1];
        if (inifile)
        {
            strcpy(inifile, message);
            strcat(inifile, bs);
            //MessageBox(NULL, (LPCTSTR)inifile, TEXT("inifile"), MB_OK);
            action = (enum ACTION)GetPrivateProfileInt("Action", "Type", ACTION_SHUTDOWN, inifile);
        }
    }
    return 0;
}
